Index: issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/Gembx.cpp	(revision 27232)
@@ -2311,129 +2517,2 @@
 
 } /*}}}*/
-void turbulentFlux(IssmDouble* pshf, IssmDouble* plhf, IssmDouble* pEC, IssmDouble Ta, IssmDouble Ts, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble ds, IssmDouble Ws, IssmDouble Vz, IssmDouble Tz, IssmDouble dIce, int sid){ /*{{{*/
-
-	//// TURBULENT HEAT FLUX
-
-	// Description: 
-	// computed the surface sensible and latent heat fluxes [W m-2], this
-	// function also calculated the mass loss/acreation due to
-	// condensation/evaporation [kg]
-
-	// Reference: 
-	// Dingman, 2002.
-
-	//// INPUTS:
-	//   Ta: 2m air temperature [K]
-	//   Ts: snow/firn/ice surface temperature [K]
-	//   V: wind speed [m s^-^1]
-	//   eAir: screen level vapor pressure [Pa]
-	//   pAir: surface pressure [Pa]
-	//   ds: surface density [kg/m^3]
-	//   Ws: surface liquid water content [kg/m^2]
-	//   Vz: height above ground at which wind (V) eas sampled [m]
-	//   Tz: height above ground at which temperature (T) was sampled [m]
-
-	/*intermediary:*/
-	IssmDouble d_air=0.0;
-	IssmDouble Ri=0.0;
-	IssmDouble z0=0.0;
-	IssmDouble coef_M=0.0;
-	IssmDouble coef_H=0.0;
-	IssmDouble An=0.0;
-	IssmDouble C=0.0;
-	IssmDouble L=0.0;
-	IssmDouble eS=0.0;
-
-	/*output: */
-	IssmDouble shf=0.0;
-	IssmDouble lhf=0.0;
-	IssmDouble EC=0.0;
-
-	if(VerboseSmb() && sid==0 && IssmComm::GetRank()==0)_printf0_("   turbulentFlux module\n");
-
-	// calculated air density [kg/m3]
-	d_air = 0.029 * pAir /(R * Ta);
-
-	//// Determine Surface Roughness
-	// Bougamont, 2006
-	// wind/temperature surface roughness height [m]
-	if (ds < dIce-Dtol && fabs(Ws) < Wtol) z0 = 0.00012;               // 0.12 mm for dry snow
-	else if (ds >= dIce-Dtol) z0 = 0.0032;                // 3.2 mm for ice 
-	else z0 = 0.0013;                // 1.3 mm for wet snow
-
-	//// Monin-Obukhov Stability Correction
-	// Reference:
-	// Ohmura, A., 1982: Climate and Energy-Balance on the Arctic Tundra.
-	// Journal of Climatology, 2, 65-84.
-
-	// if V = 0 goes to infinity therfore if V = 0 change
-	if(V< 0.01-Dtol)V=0.01;
-
-	// calculate the Bulk Richardson Number (Ri)
-	Ri = (2.0*9.81* (Vz - z0) * (Ta - Ts)) / ((Ta + Ts)* pow(V,2.0));
-	//Ri = (2.0*9.81*(Ta - Ts)) / ((Tz - z0)*(Ta + Ts)* pow(V/(Vz - z0),2.0));
-
-	// calculate Monin-Obukhov stability factors 'coefM' and 'coefH'
-
-	// do not allow Ri to exceed 0.16
-	// Ri = min(Ri, 0.19);
-	Ri = min(Ri, 0.16); //Ohmura, 1982
-
-	// calculate momentum 'coefM' stability factor
-	if (Ri > 0.0+Ttol){
-		// if stable
-		coef_M = 1.0/(1.0-5.2*Ri);
-	}
-	else {
-		coef_M =pow (1.0-18*Ri,-0.25);
-	}
-
-	// calculate heat/wind 'coef_H' stability factor
-	if (Ri <= -0.03+Ttol) coef_H = coef_M/1.3;
-	else coef_H = coef_M;
-
-	//// Bulk-transfer coefficient
-	//An =  pow(0.4,2) / pow(log(Tz/z0),2);     // Bulk-transfer coefficient
-	An =  pow(0.4,2) / (log(Tz/z0)*log(Vz/z0));     // Bulk-transfer coefficient
-	C = An * d_air * V;             // shf & lhf common coefficient
-
-	//// Sensible Heat
-	// calculate the sensible heat flux [W m-2](Patterson, 1998)
-	shf = C * CA * (Ta - Ts);
-
-	// adjust using Monin-Obukhov stability theory
-	shf = shf / (coef_M * coef_H);
-
-	// Latent Heat
-	// determine if snow pack is melting & calcualte surface vapour pressure over ice or liquid water
-	if (Ts >= CtoK-Ttol){
-		L = LV; //for liquid water at 273.15 k to vapor
-
-		//for liquid surface (assume liquid on surface when Ts == 0 deg C)
-		// Wright (1997), US Meteorological Handbook from Murphy and Koop, 2005 Appendix A
-		eS = 611.21 * exp(17.502 * (Ts - CtoK) / (240.97 + Ts - CtoK));
-	}
-	else{
-		L = LS; // latent heat of sublimation
-
-		// for an ice surface Murphy and Koop, 2005 [Equation 7]
-		eS = exp(9.550426 - 5723.265/Ts + 3.53068 * log(Ts) - 0.00728332 * Ts);
-	}
-
-	// Latent heat flux [W m-2]
-	lhf = C * L * (eAir - eS) * 0.622 / pAir;
-
-	// adjust using Monin-Obukhov stability theory (if lhf '+' then there is
-	// energy and mass gained at the surface, if '-' then there is mass and 
-	// energy loss at the surface. 
-	lhf = lhf / (coef_M * coef_H);
-
-	// mass loss (-)/acreation(+) due to evaporation/condensation [kg]
-	EC = lhf * dts / L;
-
-	/*assign output poitners: */
-	*pshf=shf;
-	*plhf=lhf;
-	*pEC=EC;
-
-} /*}}}*/
Index: issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h	(revision 27035)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h	(revision 27232)
@@ -34,8 +34,8 @@
 void albedo(IssmDouble** a, IssmDouble** adiff, int aIdx, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble cldFrac, IssmDouble aIce, IssmDouble aSnow, IssmDouble aValue, IssmDouble adThresh, IssmDouble* T, IssmDouble* W, IssmDouble P, IssmDouble EC, IssmDouble Msurf, IssmDouble clabSnow, IssmDouble clabIce, IssmDouble SZA, IssmDouble COT, IssmDouble t0wet, IssmDouble t0dry, IssmDouble K, IssmDouble dt, IssmDouble dIce, int m, int sid);
 void shortwave(IssmDouble** pswf, int swIdx, int aIdx, IssmDouble dsw, IssmDouble dswdiff, IssmDouble as, IssmDouble asdiff, IssmDouble* d, IssmDouble* dz, IssmDouble* re, IssmDouble dIce, int m, int sid);
-void thermo(IssmDouble* pEC, IssmDouble** T, IssmDouble* pulwrf, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble* swf, IssmDouble dlw, IssmDouble Ta, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble eIdx, IssmDouble teValue, IssmDouble dulwrfValue, IssmDouble teThresh, IssmDouble Ws, IssmDouble dt0, int m, IssmDouble Vz, IssmDouble Tz, IssmDouble thermo_scaling, IssmDouble dIce, int sid, bool isconstrainsurfaceT, bool isdeltaLWup);
+void thermo(IssmDouble* pshf, IssmDouble* plhf, IssmDouble* pEC, IssmDouble** T, IssmDouble* pulwrf, IssmDouble* re, IssmDouble* dz, IssmDouble* d, IssmDouble* swf, IssmDouble dlw, IssmDouble Ta, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble tcIdx, IssmDouble eIdx, IssmDouble teValue, IssmDouble dulwrfValue, IssmDouble teThresh, IssmDouble Ws, IssmDouble dt0, IssmDouble dzMin, int m, IssmDouble Vz, IssmDouble Tz, IssmDouble thermo_scaling, IssmDouble dIce, int sid, bool isconstrainsurfaceT, bool isdeltaLWup);
 void accumulation(IssmDouble** pT, IssmDouble** pdz, IssmDouble** pd, IssmDouble** pW, IssmDouble** pa, IssmDouble** padiff, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, IssmDouble* pRa, int* pm, int aIdx, int dsnowIdx, IssmDouble Tmean, IssmDouble Ta, IssmDouble P, IssmDouble dzMin, IssmDouble aSnow, IssmDouble C, IssmDouble V, IssmDouble Vmean, IssmDouble dIce, int sid);
 void melt(IssmDouble* pM, IssmDouble* pMs, IssmDouble* pR, IssmDouble* pF, IssmDouble* pmAdd, IssmDouble* pdz_add, IssmDouble** pT, IssmDouble** pd, IssmDouble** pdz, IssmDouble** pW, IssmDouble** pa, IssmDouble** padiff, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pn, IssmDouble Ra, IssmDouble dzMin, IssmDouble zMax, IssmDouble zMin, IssmDouble zTop, IssmDouble zY, IssmDouble dIce, int sid);
+void managelayers(IssmDouble* pmAdd, IssmDouble* pdz_add, IssmDouble* paddE, IssmDouble** pm, IssmDouble** pEI, IssmDouble** pEW, IssmDouble** pT, IssmDouble** pd, IssmDouble** pdz, IssmDouble** pW, IssmDouble** pa, IssmDouble** padiff, IssmDouble** pre, IssmDouble** pgdn, IssmDouble** pgsp, int* pn, IssmDouble dzMin, IssmDouble zMax, IssmDouble zMin, IssmDouble zTop, IssmDouble zY);
 void densification(IssmDouble** pd,IssmDouble** pdz, IssmDouble* T, IssmDouble* re, int denIdx, int aIdx, int swIdx, IssmDouble adThresh, IssmDouble C, IssmDouble dt, IssmDouble Tmean, IssmDouble dIce, int m, int sid);
-void turbulentFlux(IssmDouble* pshf, IssmDouble* plhf, IssmDouble* pEC, IssmDouble Ta, IssmDouble Ts, IssmDouble V, IssmDouble eAir, IssmDouble pAir, IssmDouble ds, IssmDouble Ws, IssmDouble Vz, IssmDouble Tz, IssmDouble dIce, int sid);
 #endif  /* _SurfaceMassBalancex_H*/
Index: issm/trunk/src/c/modules/UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.cpp
===================================================================
--- issm/trunk/src/c/modules/UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/UpdateDynamicConstraintsx/UpdateDynamicConstraintsx.cpp	(revision 27232)
@@ -27,5 +27,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(yg_serial);
 }
Index: issm/trunk/src/c/modules/VertexCoordinatesx/VertexCoordinatesx.cpp
===================================================================
--- issm/trunk/src/c/modules/VertexCoordinatesx/VertexCoordinatesx.cpp	(revision 27035)
+++ issm/trunk/src/c/modules/VertexCoordinatesx/VertexCoordinatesx.cpp	(revision 27232)
@@ -34,5 +34,5 @@
 	IssmDouble* z=vz->ToMPISerial();
 
-	/*Free ressources: */
+	/*Free resources: */
 	delete vx;
 	delete vy;
Index: issm/trunk/src/c/modules/modules.h
===================================================================
--- issm/trunk/src/c/modules/modules.h	(revision 27035)
+++ issm/trunk/src/c/modules/modules.h	(revision 27232)
@@ -33,5 +33,4 @@
 #include "./GetVectorFromControlInputsx/GetVectorFromControlInputsx.h"
 #include "./GiaDeflectionCorex/GiaDeflectionCorex.h"
-#include "./FourierLoveCorex/FourierLoveCorex.h"
 #include "./SetControlInputsFromVectorx/SetControlInputsFromVectorx.h"
 #include "./SetActiveNodesLSMx/SetActiveNodesLSMx.h"
Index: issm/trunk/src/c/shared/Enum/Enum.vim
===================================================================
--- issm/trunk/src/c/shared/Enum/Enum.vim	(revision 27035)
+++ issm/trunk/src/c/shared/Enum/Enum.vim	(revision 27232)
@@ -17,4 +17,7 @@
 syn keyword cConstant ParametersSTARTEnum
 syn keyword cConstant AdolcParamEnum
+syn keyword cConstant AgeStabilizationEnum
+syn keyword cConstant AgeNumRequestedOutputsEnum
+syn keyword cConstant AgeRequestedOutputsEnum
 syn keyword cConstant AmrDeviatoricErrorGroupThresholdEnum
 syn keyword cConstant AmrDeviatoricErrorMaximumEnum
@@ -115,8 +118,10 @@
 syn keyword cConstant CalvingTestIndependentRateEnum
 syn keyword cConstant CalvingUseParamEnum
-syn keyword cConstant CalvingScaleThetaEnum
-syn keyword cConstant CalvingAmpAlphaEnum
-syn keyword cConstant CalvingMidpointEnum
-syn keyword cConstant CalvingNonlinearLawEnum
+syn keyword cConstant CalvingThetaEnum
+syn keyword cConstant CalvingAlphaEnum
+syn keyword cConstant CalvingXoffsetEnum
+syn keyword cConstant CalvingYoffsetEnum
+syn keyword cConstant CalvingVelLowerboundEnum
+syn keyword cConstant CalvingVelUpperboundEnum
 syn keyword cConstant ConfigurationTypeEnum
 syn keyword cConstant ConstantsGEnum
@@ -240,4 +245,5 @@
 syn keyword cConstant HydrologydcSedimentPorosityEnum
 syn keyword cConstant HydrologydcSedimentThicknessEnum
+syn keyword cConstant HydrologyStepAdaptEnum
 syn keyword cConstant HydrologydcTransferFlagEnum
 syn keyword cConstant HydrologydcUnconfinedFlagEnum
@@ -289,5 +295,8 @@
 syn keyword cConstant LoveInnerCoreBoundaryEnum
 syn keyword cConstant LoveComplexComputationEnum
+syn keyword cConstant LoveQuadPrecisionEnum
 syn keyword cConstant LoveIntStepsPerLayerEnum
+syn keyword cConstant LoveMinIntegrationStepsEnum
+syn keyword cConstant LoveMaxIntegrationdrEnum
 syn keyword cConstant LoveKernelsEnum
 syn keyword cConstant LoveMu0Enum
@@ -301,4 +310,7 @@
 syn keyword cConstant LoveUnderflowTolEnum
 syn keyword cConstant LovePostWidderThresholdEnum
+syn keyword cConstant LoveDebugEnum
+syn keyword cConstant LoveHypergeomNZEnum
+syn keyword cConstant LoveHypergeomNAlphaEnum
 syn keyword cConstant MassFluxSegmentsEnum
 syn keyword cConstant MassFluxSegmentsPresentEnum
@@ -387,4 +399,6 @@
 syn keyword cConstant SolidearthSettingsElasticEnum
 syn keyword cConstant SolidearthSettingsViscousEnum
+syn keyword cConstant SolidearthSettingsSatelliteGraviEnum
+syn keyword cConstant SolidearthSettingsDegreeAccuracyEnum
 syn keyword cConstant SealevelchangeGeometryDoneEnum
 syn keyword cConstant SealevelchangeViscousNumStepsEnum
@@ -409,4 +423,7 @@
 syn keyword cConstant LoveTimeFreqEnum
 syn keyword cConstant LoveIsTimeEnum
+syn keyword cConstant LoveHypergeomZEnum
+syn keyword cConstant LoveHypergeomTable1Enum
+syn keyword cConstant LoveHypergeomTable2Enum
 syn keyword cConstant SealevelchangeGSelfAttractionEnum
 syn keyword cConstant SealevelchangeGViscoElasticEnum
@@ -513,4 +530,5 @@
 syn keyword cConstant SmbT0dryEnum
 syn keyword cConstant SmbT0wetEnum
+syn keyword cConstant SmbTcIdxEnum
 syn keyword cConstant SmbTeThreshEnum
 syn keyword cConstant SmbTdiffEnum
@@ -550,4 +568,5 @@
 syn keyword cConstant ThermalWatercolumnUpperlimitEnum
 syn keyword cConstant TimeEnum
+syn keyword cConstant TimesteppingAverageForcingEnum
 syn keyword cConstant TimesteppingCflCoefficientEnum
 syn keyword cConstant TimesteppingCouplingTimeEnum
@@ -566,4 +585,5 @@
 syn keyword cConstant ToolkitsTypesEnum
 syn keyword cConstant TransientAmrFrequencyEnum
+syn keyword cConstant TransientIsageEnum
 syn keyword cConstant TransientIsdamageevolutionEnum
 syn keyword cConstant TransientIsesaEnum
@@ -602,4 +622,5 @@
 syn keyword cConstant AdjointyShearEnum
 syn keyword cConstant AdjointzEnum
+syn keyword cConstant AgeEnum
 syn keyword cConstant AirEnum
 syn keyword cConstant ApproximationEnum
@@ -731,4 +752,5 @@
 syn keyword cConstant FrictionCoefficientEnum
 syn keyword cConstant FrictionCoefficientcoulombEnum
+syn keyword cConstant FrictionCoulombWaterPressureEnum
 syn keyword cConstant FrictionEffectivePressureEnum
 syn keyword cConstant FrictionMEnum
@@ -738,5 +760,7 @@
 syn keyword cConstant FrictionSedimentCompressibilityCoefficientEnum
 syn keyword cConstant FrictionTillFrictionAngleEnum
+syn keyword cConstant FrictionSchoofWaterPressureEnum
 syn keyword cConstant FrictionWaterLayerEnum
+syn keyword cConstant FrictionWaterPressureEnum
 syn keyword cConstant FrictionfEnum
 syn keyword cConstant FrontalForcingsBasinIdEnum
@@ -851,4 +875,5 @@
 syn keyword cConstant SealevelEnum
 syn keyword cConstant SealevelGRDEnum
+syn keyword cConstant SatGraviGRDEnum
 syn keyword cConstant SealevelBarystaticMaskEnum
 syn keyword cConstant SealevelBarystaticIceMaskEnum
@@ -890,25 +915,19 @@
 syn keyword cConstant SealevelUNorthEsaEnum
 syn keyword cConstant SealevelchangeIndicesEnum
-syn keyword cConstant SealevelchangeGEnum
-syn keyword cConstant SealevelchangeGUEnum
-syn keyword cConstant SealevelchangeGEEnum
-syn keyword cConstant SealevelchangeGNEnum
+syn keyword cConstant SealevelchangeAlphaIndexEnum
+syn keyword cConstant SealevelchangeAzimuthIndexEnum
 syn keyword cConstant SealevelchangeGrotEnum
+syn keyword cConstant SealevelchangeGSatGravirotEnum
 syn keyword cConstant SealevelchangeGUrotEnum
 syn keyword cConstant SealevelchangeGNrotEnum
 syn keyword cConstant SealevelchangeGErotEnum
-syn keyword cConstant SealevelchangeGsubelOceanEnum
-syn keyword cConstant SealevelchangeGUsubelOceanEnum
-syn keyword cConstant SealevelchangeGEsubelOceanEnum
-syn keyword cConstant SealevelchangeGNsubelOceanEnum
-syn keyword cConstant SealevelchangeGsubelIceEnum
-syn keyword cConstant SealevelchangeGUsubelIceEnum
-syn keyword cConstant SealevelchangeGEsubelIceEnum
-syn keyword cConstant SealevelchangeGNsubelIceEnum
-syn keyword cConstant SealevelchangeGsubelHydroEnum
-syn keyword cConstant SealevelchangeGUsubelHydroEnum
-syn keyword cConstant SealevelchangeGEsubelHydroEnum
-syn keyword cConstant SealevelchangeGNsubelHydroEnum
+syn keyword cConstant SealevelchangeAlphaIndexOceanEnum
+syn keyword cConstant SealevelchangeAlphaIndexIceEnum
+syn keyword cConstant SealevelchangeAlphaIndexHydroEnum
+syn keyword cConstant SealevelchangeAzimuthIndexOceanEnum
+syn keyword cConstant SealevelchangeAzimuthIndexIceEnum
+syn keyword cConstant SealevelchangeAzimuthIndexHydroEnum
 syn keyword cConstant SealevelchangeViscousRSLEnum
+syn keyword cConstant SealevelchangeViscousSGEnum
 syn keyword cConstant SealevelchangeViscousUEnum
 syn keyword cConstant SealevelchangeViscousNEnum
@@ -1112,6 +1131,4 @@
 syn keyword cConstant WaterfractionEnum
 syn keyword cConstant WaterheightEnum
-syn keyword cConstant FrictionWaterPressureEnum
-syn keyword cConstant FrictionWaterPressureNoiseEnum
 syn keyword cConstant WeightsLevelsetObservationEnum
 syn keyword cConstant WeightsSurfaceObservationEnum
@@ -1225,4 +1242,5 @@
 syn keyword cConstant AdjointBalancethicknessAnalysisEnum
 syn keyword cConstant AdjointHorizAnalysisEnum
+syn keyword cConstant AgeAnalysisEnum
 syn keyword cConstant AggressiveMigrationEnum
 syn keyword cConstant AmrBamgEnum
@@ -1295,4 +1313,5 @@
 syn keyword cConstant DoubleArrayInputEnum
 syn keyword cConstant ArrayInputEnum
+syn keyword cConstant IntArrayInputEnum
 syn keyword cConstant DoubleExternalResultEnum
 syn keyword cConstant DoubleMatArrayParamEnum
@@ -1359,4 +1378,6 @@
 syn keyword cConstant HydrologyShreveAnalysisEnum
 syn keyword cConstant HydrologySolutionEnum
+syn keyword cConstant HydrologySubstepsEnum
+syn keyword cConstant HydrologySubTimeEnum
 syn keyword cConstant HydrologydcEnum
 syn keyword cConstant HydrologypismEnum
@@ -1410,4 +1431,6 @@
 syn keyword cConstant LovePMTF1tEnum
 syn keyword cConstant LovePMTF2tEnum
+syn keyword cConstant LoveYiEnum
+syn keyword cConstant LoveRhsEnum
 syn keyword cConstant LoveSolutionEnum
 syn keyword cConstant MINIEnum
@@ -1665,4 +1688,5 @@
 syn keyword cType Input
 syn keyword cType Inputs
+syn keyword cType IntArrayInput
 syn keyword cType IntInput
 syn keyword cType IntMatParam
@@ -1741,4 +1765,5 @@
 syn keyword cType AdjointBalancethicknessAnalysis
 syn keyword cType AdjointHorizAnalysis
+syn keyword cType AgeAnalysis
 syn keyword cType Analysis
 syn keyword cType Balancethickness2Analysis
Index: issm/trunk/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk/src/c/shared/Enum/EnumDefinitions.h	(revision 27035)
+++ issm/trunk/src/c/shared/Enum/EnumDefinitions.h	(revision 27232)
@@ -11,4 +11,7 @@
 	/*Parameters{{{*/
 	AdolcParamEnum,
+	AgeStabilizationEnum,
+	AgeNumRequestedOutputsEnum,
+	AgeRequestedOutputsEnum,
 	AmrDeviatoricErrorGroupThresholdEnum,
 	AmrDeviatoricErrorMaximumEnum,
@@ -109,8 +112,10 @@
 	CalvingTestIndependentRateEnum,
 	CalvingUseParamEnum,
-	CalvingScaleThetaEnum,
-	CalvingAmpAlphaEnum,
-	CalvingMidpointEnum,
-	CalvingNonlinearLawEnum,
+	CalvingThetaEnum,
+	CalvingAlphaEnum,
+	CalvingXoffsetEnum,
+	CalvingYoffsetEnum,
+	CalvingVelLowerboundEnum,
+	CalvingVelUpperboundEnum,
 	ConfigurationTypeEnum,
 	ConstantsGEnum,
@@ -234,4 +239,5 @@
 	HydrologydcSedimentPorosityEnum,
 	HydrologydcSedimentThicknessEnum,
+	HydrologyStepAdaptEnum,
 	HydrologydcTransferFlagEnum,
 	HydrologydcUnconfinedFlagEnum,
@@ -283,5 +289,8 @@
 	LoveInnerCoreBoundaryEnum,
 	LoveComplexComputationEnum,
+	LoveQuadPrecisionEnum,
 	LoveIntStepsPerLayerEnum,
+	LoveMinIntegrationStepsEnum,
+	LoveMaxIntegrationdrEnum,
 	LoveKernelsEnum,
 	LoveMu0Enum,
@@ -295,4 +304,7 @@
 	LoveUnderflowTolEnum,
 	LovePostWidderThresholdEnum,
+	LoveDebugEnum,
+	LoveHypergeomNZEnum,
+	LoveHypergeomNAlphaEnum,
 	MassFluxSegmentsEnum,
 	MassFluxSegmentsPresentEnum,
@@ -381,4 +393,6 @@
 	SolidearthSettingsElasticEnum,
 	SolidearthSettingsViscousEnum,
+	SolidearthSettingsSatelliteGraviEnum,
+	SolidearthSettingsDegreeAccuracyEnum,
 	SealevelchangeGeometryDoneEnum,
 	SealevelchangeViscousNumStepsEnum,
@@ -403,4 +417,7 @@
 	LoveTimeFreqEnum,
 	LoveIsTimeEnum,
+	LoveHypergeomZEnum,
+	LoveHypergeomTable1Enum,
+	LoveHypergeomTable2Enum,
 	SealevelchangeGSelfAttractionEnum,
 	SealevelchangeGViscoElasticEnum,
@@ -507,4 +524,5 @@
 	SmbT0dryEnum,
 	SmbT0wetEnum,
+	SmbTcIdxEnum,
 	SmbTeThreshEnum,
 	SmbTdiffEnum,
@@ -544,4 +562,5 @@
 	ThermalWatercolumnUpperlimitEnum,
 	TimeEnum,
+	TimesteppingAverageForcingEnum,
 	TimesteppingCflCoefficientEnum,
 	TimesteppingCouplingTimeEnum,
@@ -560,4 +579,5 @@
 	ToolkitsTypesEnum,
 	TransientAmrFrequencyEnum,
+	TransientIsageEnum,
 	TransientIsdamageevolutionEnum,
 	TransientIsesaEnum,
@@ -598,4 +618,5 @@
 	AdjointyShearEnum,
 	AdjointzEnum,
+	AgeEnum,
 	AirEnum,
 	ApproximationEnum,
@@ -727,4 +748,5 @@
 	FrictionCoefficientEnum,
 	FrictionCoefficientcoulombEnum,
+	FrictionCoulombWaterPressureEnum,
 	FrictionEffectivePressureEnum,
 	FrictionMEnum,
@@ -734,5 +756,7 @@
 	FrictionSedimentCompressibilityCoefficientEnum,
 	FrictionTillFrictionAngleEnum,
+	FrictionSchoofWaterPressureEnum,
 	FrictionWaterLayerEnum,
+	FrictionWaterPressureEnum,
 	FrictionfEnum,
 	FrontalForcingsBasinIdEnum,
@@ -847,4 +871,5 @@
 	SealevelEnum,
 	SealevelGRDEnum,
+	SatGraviGRDEnum,
 	SealevelBarystaticMaskEnum,
 	SealevelBarystaticIceMaskEnum,
@@ -886,25 +911,19 @@
 	SealevelUNorthEsaEnum,
 	SealevelchangeIndicesEnum,
-	SealevelchangeGEnum,
-	SealevelchangeGUEnum,
-	SealevelchangeGEEnum,
-	SealevelchangeGNEnum,
+	SealevelchangeAlphaIndexEnum,
+	SealevelchangeAzimuthIndexEnum,
 	SealevelchangeGrotEnum,
+	SealevelchangeGSatGravirotEnum,
 	SealevelchangeGUrotEnum,
 	SealevelchangeGNrotEnum,
 	SealevelchangeGErotEnum,
-	SealevelchangeGsubelOceanEnum,
-	SealevelchangeGUsubelOceanEnum,
-	SealevelchangeGEsubelOceanEnum,
-	SealevelchangeGNsubelOceanEnum,
-	SealevelchangeGsubelIceEnum,
-	SealevelchangeGUsubelIceEnum,
-	SealevelchangeGEsubelIceEnum,
-	SealevelchangeGNsubelIceEnum,
-	SealevelchangeGsubelHydroEnum,
-	SealevelchangeGUsubelHydroEnum,
-	SealevelchangeGEsubelHydroEnum,
-	SealevelchangeGNsubelHydroEnum,
+	SealevelchangeAlphaIndexOceanEnum,
+	SealevelchangeAlphaIndexIceEnum,
+	SealevelchangeAlphaIndexHydroEnum,
+	SealevelchangeAzimuthIndexOceanEnum,
+	SealevelchangeAzimuthIndexIceEnum,
+	SealevelchangeAzimuthIndexHydroEnum,
 	SealevelchangeViscousRSLEnum,
+	SealevelchangeViscousSGEnum,
 	SealevelchangeViscousUEnum,
 	SealevelchangeViscousNEnum,
@@ -1109,6 +1128,4 @@
 	WaterfractionEnum,
 	WaterheightEnum,
-	FrictionWaterPressureEnum,
-	FrictionWaterPressureNoiseEnum,
 	WeightsLevelsetObservationEnum,
 	WeightsSurfaceObservationEnum,
@@ -1224,4 +1241,5 @@
 	AdjointBalancethicknessAnalysisEnum,
 	AdjointHorizAnalysisEnum,
+	AgeAnalysisEnum,
 	AggressiveMigrationEnum,
 	AmrBamgEnum,
@@ -1294,4 +1312,5 @@
 	DoubleArrayInputEnum,
 	ArrayInputEnum,
+	IntArrayInputEnum,
 	DoubleExternalResultEnum,
 	DoubleMatArrayParamEnum,
@@ -1358,4 +1377,6 @@
 	HydrologyShreveAnalysisEnum,
 	HydrologySolutionEnum,
+	HydrologySubstepsEnum,
+	HydrologySubTimeEnum,
 	HydrologydcEnum,
 	HydrologypismEnum,
@@ -1409,4 +1430,6 @@
 	LovePMTF1tEnum,
 	LovePMTF2tEnum,
+	LoveYiEnum,
+	LoveRhsEnum,
 	LoveSolutionEnum,
 	MINIEnum,
